#include <stdio.h>
#include <sys/time.h>
#include "../common.h"

//OPERATION(x)  and UPDATE_TIME(time) is defined in ../common.h like that it is the same for C and C++


int main(){
    int i, k;
    volatile int result[SIZE]; //volatile is used to be sure that the compiler  execute the calcul.
    int tab[SIZE]={0};
    int total1=0, total2=0, total3=0, total;
    clock_t init_t, start_t, end_t;

    init_t=start_t = clock();

    for (k=0; k<TRIALS_NB; k++ ){
        for (i=0; i<SIZE; i++){
            OPERATION(tab[i]);
        }
    }
    for (int i=0; i<SIZE; i++) result[i]=tab[i];
    UPDATE_TIME(total1);
    
    for (k=0; k<TRIALS_NB; k++ ){
        for (i=0; i!=SIZE; i++){
            OPERATION(tab[i]);
        }
    }
    for (int i=0; i<SIZE; i++) result[i]=tab[i];
    UPDATE_TIME(total2);

    
    for (k=0; k<TRIALS_NB; k++ ){
        for (i=SIZE-1; i--;){
            OPERATION(tab[i]);
        }
    }
    for (int i=0; i<SIZE; i++) result[i]=tab[i];
    UPDATE_TIME(total3);

    total = (end_t-init_t)*1000/CLOCKS_PER_SEC;
    
    fprintf(stderr, "Finish '<' %dms '!=' %dms '--' %dms total:%dms\n", total1, total2, total3, total);
    
    return 0;
}
